> ## Documentation Index
> Fetch the complete documentation index at: https://docs.siftstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# DetectConfig

> Detects the config for a data import.



## OpenAPI

````yaml /openapi.json post /api/v2/data-imports:detect-config
openapi: 3.0.0
info:
  title: Sift API
  version: '1.0'
servers:
  - url: https://api.siftstack.com
    description: Production
  - url: https://gov.api.siftstack.com
    description: Gov
security:
  - BearerAuth: []
tags:
  - name: TagService
    description: Service to programmatically interact with [tags](/glossary#tag).
  - name: CampaignService
  - name: ProtobufDescriptorService
    description: >-
      Service to programmatically interact with protobuf descriptors used for
      protobuf ingestion.
    externalDocs:
      description: Read more about what protobuf ingestion.
      url: /ingestion/protobuf_ingestion
  - name: AnnotationLogService
    description: >-
      Service to programmatically interact with [annotation
      logs](/glossary#annotation).
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: MetadataService
  - name: DlqErrorsService
  - name: RuleService
    description: Service to programmatically interact with rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: WebhookService
  - name: UserDefinedFunctionService
  - name: ReportTemplateService
  - name: RemoteFileService
  - name: PingService
  - name: FamilyService
    description: Service to programmatically interact with family configurations.
  - name: ExternalSyncService
  - name: ReportService
  - name: NotificationService
    description: Service to programmatically interact with in-app notifications.
  - name: ChannelSchemaService
    description: Service to programmatically interact with channel schemas
  - name: IngestService
  - name: UserService
    description: Service to programmatically interact with user objects.
  - name: TestReportService
    description: Service to manage test reports
  - name: PrincipalAttributeService
    description: Service to manage ABAC principal attributes.
  - name: ChannelService
    description: Service to programmatically interact with [channels](/glossary#channel).
    externalDocs:
      description: Read more about what channels are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265453943
  - name: DataImportService
  - name: ExportService
  - name: PolicyService
    description: Service to manage ABAC policies.
  - name: ApiKeyService
  - name: CommentService
    description: >-
      Service to programmatically interact with comments attached to resources
      in the platform.
  - name: JobService
  - name: UserGroupService
  - name: ResourceAttributeService
    description: Service to manage ABAC resource attributes (entity attributes).
  - name: AutomationService
  - name: ViewService
    description: Service to programmatically interact with views.
    externalDocs:
      description: Read more about what views are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/298188809
  - name: UnitService
  - name: DocsService
  - name: RoleService
  - name: SavedSearchService
  - name: RuleEvaluationService
    description: Service to evaluate rules.
    externalDocs:
      description: Read more about what rules are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421102
  - name: RunService
    description: Service to programmatically interact with [runs](/glossary#run).
    externalDocs:
      description: Read more about what runs are.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265454053
  - name: PanelConfigurationService
    description: Service to programmatically interact with panel configurations.
  - name: IngestionConfigService
    description: >-
      Service to programmatically interact with [ingestion
      configs](/glossary#ingestion-config).
    externalDocs:
      description: Read more about what ingestion configs are.
      url: /ingestion/creating-amend-ingestion-config
  - name: CalculatedChannelService
  - name: CalculatedChannelsService
    description: Service to programmatically interact with calculated channels.
    externalDocs:
      description: Read more about calculated channels.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265421153
  - name: AnnotationService
    description: Service to programmatically interact with annotations.
    externalDocs:
      description: Read more about annotations.
      url: >-
        https://customer.support.siftstack.com/servicedesk/customer/portal/2/article/265486685
  - name: DataService
    description: Service to query data
  - name: MeService
  - name: AssetService
    description: Service to programmatically interact with [assets](/glossary#asset).
    externalDocs:
      description: Read more about what assets are.
      url: /data-model
paths:
  /api/v2/data-imports:detect-config:
    post:
      tags:
        - DataImportService
      summary: DetectConfig
      description: Detects the config for a data import.
      operationId: DataImportService_DetectConfigV2
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/v2DetectConfigRequest'
        required: true
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/v2DetectConfigResponse'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/rpcStatus'
components:
  schemas:
    v2DetectConfigRequest:
      type: object
      properties:
        data:
          type: string
          format: byte
        type:
          $ref: '#/components/schemas/v2DataTypeKey'
    v2DetectConfigResponse:
      type: object
      properties:
        csvConfig:
          $ref: '#/components/schemas/v2CsvConfig'
        parquetConfig:
          $ref: '#/components/schemas/v2ParquetConfig'
        hdf5Config:
          $ref: '#/components/schemas/v2Hdf5Config'
        tdmsConfig:
          $ref: '#/components/schemas/v2TDMSConfig'
    rpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    v2DataTypeKey:
      type: string
      enum:
        - DATA_TYPE_KEY_UNSPECIFIED
        - DATA_TYPE_KEY_CSV
        - DATA_TYPE_KEY_TDMS
        - DATA_TYPE_KEY_CH10
        - DATA_TYPE_KEY_PARQUET_FLATDATASET
        - DATA_TYPE_KEY_PARQUET_SINGLE_CHANNEL_PER_ROW
        - DATA_TYPE_KEY_HDF5
        - DATA_TYPE_KEY_ULOG
      default: DATA_TYPE_KEY_UNSPECIFIED
    v2CsvConfig:
      type: object
      properties:
        assetName:
          type: string
        runName:
          type: string
        runId:
          type: string
          description: >-
            The id of the run to add this data to. If set, `run_name` is
            ignored.
        firstDataRow:
          type: integer
          format: int64
          description: >-
            The first row to start reading as data. Can be used to skip header
            rows.

            The first row in the file is 1.
        timeColumn:
          $ref: '#/components/schemas/v2CsvTimeColumn'
        dataColumns:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/commontypev1ChannelConfig'
          description: >-
            A map from column number (1-indexed) to the channel configuration
            for that column.
        numRows:
          type: string
          format: uint64
          description: This will be read on upload from the file if not set.
        useEmbeddedConfig:
          type: boolean
          description: >-
            If true, the time and data column configuration is read from a
            config

            embedded in the file (written when the file was exported with

            embed_channel_configs). Any time_column/data_columns supplied here
            are

            ignored and replaced by the embedded config.
    v2ParquetConfig:
      type: object
      properties:
        assetName:
          type: string
        runName:
          type: string
        runId:
          type: string
          description: >-
            The id of the run to add this data to. If set, `run_name` is
            ignored.
        flatDataset:
          $ref: '#/components/schemas/v2ParquetFlatDatasetConfig'
        singleChannelPerRow:
          $ref: '#/components/schemas/v2ParquetSingleChannelPerRowConfig'
        footerOffset:
          type: string
          format: uint64
        footerLength:
          type: integer
          format: int64
        complexTypesImportMode:
          $ref: '#/components/schemas/v2ParquetComplexTypesImportMode'
    v2Hdf5Config:
      type: object
      properties:
        assetName:
          type: string
        runName:
          type: string
        runId:
          type: string
          description: >-
            The id of the run to add this data to. If set, `run_name` is
            ignored.
        data:
          type: array
          items:
            $ref: '#/components/schemas/v2Hdf5DataConfig'
        timeFormat:
          $ref: '#/components/schemas/v2TimeFormat'
        relativeStartTime:
          type: string
          format: date-time
    v2TDMSConfig:
      type: object
      properties:
        assetName:
          type: string
        runName:
          type: string
        startTimeOverride:
          type: string
          format: date-time
          description: >-
            Override the wf_start_time metadata field for all channels.

            Useful if your waveform channels have wf_increment but no
            wf_start_time (Veristand is guilty of this).
        fileSize:
          type: string
          format: uint64
          description: >-
            The file size in bytes.

            If the file has truncated chunks, this will be required to pass
            validation.
        runId:
          type: string
          description: >-
            The id of the run to add this data to. If set, `run_name` is
            ignored.
        data:
          type: array
          items:
            $ref: '#/components/schemas/v2TdmsDataConfig'
          description: |-
            If no data entries are present attempt to ingest everything relying
            on the fallback method for any ambiguous channels.
        fallbackMethod:
          $ref: '#/components/schemas/v2TdmsFallbackMethod'
        timeFormat:
          $ref: '#/components/schemas/v2TimeFormat'
        relativeStartTime:
          type: string
          format: date-time
          description: Relative start time for channels using a non standard time channel.
        importFileProperties:
          type: boolean
          description: |-
            If true, will import TDMS file properties to the run as metadata.
            Only valid if a run_name or run_id is set.
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    v2CsvTimeColumn:
      type: object
      properties:
        columnNumber:
          type: integer
          format: int64
          description: The column number (1-indexed) of the time column.
        format:
          $ref: '#/components/schemas/v2TimeFormat'
        relativeStartTime:
          type: string
          format: date-time
    commontypev1ChannelConfig:
      type: object
      properties:
        name:
          type: string
        units:
          type: string
        description:
          type: string
        dataType:
          $ref: '#/components/schemas/v1ChannelDataType'
        enumTypes:
          type: array
          items:
            $ref: '#/components/schemas/v1ChannelEnumType'
        bitFieldElements:
          type: array
          items:
            $ref: '#/components/schemas/v1ChannelBitFieldElement'
        metadata:
          type: array
          items:
            $ref: '#/components/schemas/v1MetadataValue'
    v2ParquetFlatDatasetConfig:
      type: object
      properties:
        timeColumn:
          $ref: '#/components/schemas/v2ParquetTimeColumn'
        dataColumns:
          type: array
          items:
            $ref: '#/components/schemas/v2ParquetDataColumn'
        useEmbeddedConfig:
          type: boolean
          description: >-
            If true, the time and data column configuration is read from the
            config

            embedded in the file's Arrow field metadata (written when the file
            was

            exported with embed_channel_configs). Any time_column/data_columns
            supplied

            here are ignored and replaced by the embedded config.
    v2ParquetSingleChannelPerRowConfig:
      type: object
      properties:
        timeColumn:
          $ref: '#/components/schemas/v2ParquetTimeColumn'
        columns:
          type: array
          items:
            $ref: '#/components/schemas/v2ParquetColumn'
          description: Detected columns.
        singleChannel:
          $ref: '#/components/schemas/v2ParquetSingleChannelPerRowSingleChannelConfig'
        multiChannel:
          $ref: '#/components/schemas/v2ParquetSingleChannelPerRowMultiChannelConfig'
    v2ParquetComplexTypesImportMode:
      type: string
      enum:
        - PARQUET_COMPLEX_TYPES_IMPORT_MODE_UNSPECIFIED
        - PARQUET_COMPLEX_TYPES_IMPORT_MODE_IGNORE
        - PARQUET_COMPLEX_TYPES_IMPORT_MODE_BOTH
        - PARQUET_COMPLEX_TYPES_IMPORT_MODE_STRING
        - PARQUET_COMPLEX_TYPES_IMPORT_MODE_BYTES
      default: PARQUET_COMPLEX_TYPES_IMPORT_MODE_UNSPECIFIED
      description: |2-
         - PARQUET_COMPLEX_TYPES_IMPORT_MODE_IGNORE: Ignore complex types and do not ingest them.
         - PARQUET_COMPLEX_TYPES_IMPORT_MODE_BOTH: Import complex types as both Arrow bytes and JSON strings.
         - PARQUET_COMPLEX_TYPES_IMPORT_MODE_STRING: Import complex types as only JSON strings.
         - PARQUET_COMPLEX_TYPES_IMPORT_MODE_BYTES: Import complex types as only Arrow bytes.
    v2Hdf5DataConfig:
      type: object
      properties:
        timeDataset:
          type: string
        timeIndex:
          type: string
          format: uint64
        valueDataset:
          type: string
        valueIndex:
          type: string
          format: uint64
        channelConfig:
          $ref: '#/components/schemas/commontypev1ChannelConfig'
        timeField:
          type: string
          description: For compound types, allow specifying which fields to use.
        valueField:
          type: string
    v2TimeFormat:
      type: string
      enum:
        - TIME_FORMAT_UNSPECIFIED
        - TIME_FORMAT_RELATIVE_NANOSECONDS
        - TIME_FORMAT_RELATIVE_MICROSECONDS
        - TIME_FORMAT_RELATIVE_MILLISECONDS
        - TIME_FORMAT_RELATIVE_SECONDS
        - TIME_FORMAT_RELATIVE_MINUTES
        - TIME_FORMAT_RELATIVE_HOURS
        - TIME_FORMAT_ABSOLUTE_RFC3339
        - TIME_FORMAT_ABSOLUTE_DATETIME
        - TIME_FORMAT_ABSOLUTE_UNIX_SECONDS
        - TIME_FORMAT_ABSOLUTE_UNIX_MILLISECONDS
        - TIME_FORMAT_ABSOLUTE_UNIX_MICROSECONDS
        - TIME_FORMAT_ABSOLUTE_UNIX_NANOSECONDS
      default: TIME_FORMAT_UNSPECIFIED
    v2TdmsDataConfig:
      type: object
      properties:
        groupName:
          type: string
          description: The TDMS group name associated with this channel.
        channelName:
          type: string
          description: The TDMS channel name associated with this channel.
        channelConfig:
          $ref: '#/components/schemas/commontypev1ChannelConfig'
        timeChannelName:
          type: string
          description: |-
            The time channel associated with this channel. If this is empty
            then we assume it's a waveform channel with waveform properties.
        scaled:
          type: boolean
          description: >-
            Whether to import scaled or raw values. Defaults to True to import
            scaled values.
        complexComponent:
          $ref: '#/components/schemas/v2TdmsComplexComponent'
    v2TdmsFallbackMethod:
      type: string
      enum:
        - TDMS_FALLBACK_METHOD_UNSPECIFIED
        - TDMS_FALLBACK_METHOD_FAIL_ON_ERROR
        - TDMS_FALLBACK_METHOD_IGNORE_ERROR
      default: TDMS_FALLBACK_METHOD_UNSPECIFIED
      description: |-
        The fallback method tells the importer how to treat channels without
        any timing information (i.e, waveform properties or time channels).

         - TDMS_FALLBACK_METHOD_FAIL_ON_ERROR: Fails the import if any specified channels have missing timing information.
         - TDMS_FALLBACK_METHOD_IGNORE_ERROR: Ignores channels without any timing information.
    v1ChannelDataType:
      type: string
      enum:
        - CHANNEL_DATA_TYPE_UNSPECIFIED
        - CHANNEL_DATA_TYPE_DOUBLE
        - CHANNEL_DATA_TYPE_STRING
        - CHANNEL_DATA_TYPE_ENUM
        - CHANNEL_DATA_TYPE_BIT_FIELD
        - CHANNEL_DATA_TYPE_BOOL
        - CHANNEL_DATA_TYPE_FLOAT
        - CHANNEL_DATA_TYPE_INT_32
        - CHANNEL_DATA_TYPE_UINT_32
        - CHANNEL_DATA_TYPE_INT_64
        - CHANNEL_DATA_TYPE_UINT_64
        - CHANNEL_DATA_TYPE_BYTES
      default: CHANNEL_DATA_TYPE_UNSPECIFIED
    v1ChannelEnumType:
      type: object
      properties:
        name:
          type: string
        key:
          type: integer
          format: int64
        isSigned:
          type: boolean
      required:
        - name
        - key
    v1ChannelBitFieldElement:
      type: object
      properties:
        name:
          type: string
        index:
          type: integer
          format: int32
          description: >-
            The index of this element's first bit in the logical bit field
            array.
        bitCount:
          type: integer
          format: int64
      required:
        - name
        - index
        - bitCount
    v1MetadataValue:
      type: object
      properties:
        key:
          $ref: '#/components/schemas/v1MetadataKey'
        stringValue:
          type: string
        numberValue:
          type: number
          format: double
        booleanValue:
          type: boolean
        relationValue:
          $ref: '#/components/schemas/v1MetadataRelationValue'
        archivedDate:
          type: string
          format: date-time
        isArchived:
          type: boolean
          description: >-
            Whether the metadata value is archived. This is inferred from
            whether archived_date is set.
      required:
        - key
    v2ParquetTimeColumn:
      type: object
      properties:
        path:
          type: string
        format:
          $ref: '#/components/schemas/v2TimeFormat'
        relativeStartTime:
          type: string
          format: date-time
    v2ParquetDataColumn:
      type: object
      properties:
        path:
          type: string
        channelConfig:
          $ref: '#/components/schemas/commontypev1ChannelConfig'
    v2ParquetColumn:
      type: object
      properties:
        path:
          type: string
        columnConfig:
          $ref: '#/components/schemas/commontypev1ChannelConfig'
    v2ParquetSingleChannelPerRowSingleChannelConfig:
      type: object
      properties:
        dataPath:
          type: string
        channel:
          $ref: '#/components/schemas/commontypev1ChannelConfig'
    v2ParquetSingleChannelPerRowMultiChannelConfig:
      type: object
      properties:
        namePath:
          type: string
        dataPath:
          type: string
    v2TdmsComplexComponent:
      type: string
      enum:
        - TDMS_COMPLEX_COMPONENT_UNSPECIFIED
        - TDMS_COMPLEX_COMPONENT_REAL
        - TDMS_COMPLEX_COMPONENT_IMAGINARY
      default: TDMS_COMPLEX_COMPONENT_UNSPECIFIED
      description: ' - TDMS_COMPLEX_COMPONENT_UNSPECIFIED: Default is to select the real component.'
    v1MetadataKey:
      type: object
      properties:
        name:
          type: string
        type:
          $ref: '#/components/schemas/v1MetadataKeyType'
        archivedDate:
          type: string
          format: date-time
        isArchived:
          type: boolean
          description: >-
            Whether the metadata key is archived. This is inferred from whether
            archived_date is set.


            The filter field type this key maps to, so a client can build a CEL
            filter
             against it (`metadata["<name>"]`) and resolve its operators and functions
             from FilterGrammarService. Derived from `type`.
      required:
        - name
        - type
    v1MetadataRelationValue:
      type: object
      properties:
        resourceType:
          type: string
        resourceId:
          type: string
      required:
        - resourceType
        - resourceId
    v1MetadataKeyType:
      type: string
      enum:
        - METADATA_KEY_TYPE_UNSPECIFIED
        - METADATA_KEY_TYPE_STRING
        - METADATA_KEY_TYPE_NUMBER
        - METADATA_KEY_TYPE_BOOLEAN
        - METADATA_KEY_TYPE_RELATION
      default: METADATA_KEY_TYPE_UNSPECIFIED
      description: |-
        Metadata key type.

         - METADATA_KEY_TYPE_STRING: string
         - METADATA_KEY_TYPE_NUMBER: number
         - METADATA_KEY_TYPE_BOOLEAN: boolean
         - METADATA_KEY_TYPE_RELATION: relation — references another resource by UUID (e.g. folder membership)
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````